// SocketTools 5.0 Library Edition
// Copyright 2007 Catalyst Development Corporation
// All rights reserved
//
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
//
#ifndef _INC_CLASS_CCLIPBOARD
#define _INC_CLASS_CCLIPBOARD

#define CF_TEXT             1
#define CF_BITMAP           2
#define CF_METAFILEPICT     3
#define CF_SYLK             4
#define CF_DIF              5
#define CF_TIFF             6
#define CF_OEMTEXT          7
#define CF_DIB              8
#define CF_PALETTE          9
#define CF_PENDATA          10
#define CF_RIFF             11
#define CF_WAVE             12
#define CF_UNICODETEXT      13
#define CF_ENHMETAFILE      14

#define GMEM_FIXED          0x0000
#define GMEM_MOVEABLE       0x0002
#define GMEM_NOCOMPACT      0x0010
#define GMEM_NODISCARD      0x0020
#define GMEM_ZEROINIT       0x0040
#define GMEM_MODIFY         0x0080
#define GMEM_DISCARDABLE    0x0100
#define GMEM_NOT_BANKED     0x1000
#define GMEM_SHARE          0x2000
#define GMEM_DDESHARE       0x2000
#define GMEM_NOTIFY         0x4000
#define GMEM_LOWER          GMEM_NOT_BANKED
#define GMEM_VALID_FLAGS    0x7F72
#define GMEM_INVALID_HANDLE 0x8000

#define GHND                (GMEM_MOVEABLE | GMEM_ZEROINIT)
#define GPTR                (GMEM_FIXED | GMEM_ZEROINIT)

declare import,OpenClipboard(unsigned int hWndOwner), int;
declare import,CloseClipboard(), int;
declare import,CountClipboardFormats(), int;
declare import,EmptyClipboard(), int;
declare import,EnumClipboardFormats(unsigned int nFormat), unsigned int;
declare import,GetClipboardData(unsigned int nFormat), unsigned int;
declare import,GetClipboardFormatNameA(unsigned int nFormat, pointer lpFormatName, int nMaxLength), int;
declare import,GetClipboardOwner(), unsigned int;
declare import,GetOpenClipboardWindow(), unsigned int;
declare import,IsClipboardFormatAvailable(unsigned int nFormat), int;
declare import,RegisterClipboardFormatA(string strFormat), unsigned int;
declare import,SetClipboardData(unsigned int nFormat, unsigned int hMem), unsigned int;
declare import,GlobalAlloc(unsigned int uFlags, unsigned int dwBytes), unsigned int;
declare import,GlobalLock(unsigned int hMem), pointer;
declare import,GlobalUnlock(unsigned int hMem), int;
declare import,GlobalFree(unsigned int hMem), unsigned int;
declare import,GlobalSize(unsigned int hMem), unsigned int;
declare import,RtlMoveMemory(pointer lpDestination, pointer lpSource, unsigned int nLength);
declare import,RtlZeroMemory(pointer lpBuffer, unsigned int nLength);
declare import,lstrlenA(pointer lpString), int;

class CClipboard
{
	declare CClipboard();
	declare _CClipboard();

	declare Open(opt unsigned int hWndOwner = 0);
	declare Close(), int;
	declare Empty(), int;
	declare GetData(unsigned int nFormat, unsigned int *phMem), int;
	declare GetFirstFormat(), unsigned int;
	declare GetFormatCount(), int;
	declare GetFormatName(unsigned int nFormat, string strFormat), int;
	declare GetNextFormat(), unsigned int;
	declare GetOpenWindow(), unsigned int;
	declare GetOwner(), unsigned int;
	declare GetString(), heap;
	declare GetText(pointer lpBuffer, int nMaxLength), int;
	declare GetTextLength(), int;
	declare IsFormatAvailable(unsigned int nFormat), int;
	declare RegisterFormat(string strFormat), unsigned int;
	declare SetData(unsigned int nFormat, unsigned int hMem), int;
	declare SetText(pointer lpText, opt int nLength = -1), int;

	int m_bOpened;
	unsigned int m_hClipboard;
	unsigned int m_nFormat;
}
#endif
