// SocketTools 5.0 Library Edition
// Copyright 2007 Catalyst Development Corporation
// All rights reserved
//
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
//

#ifndef _INC_TERMINAL
#define _INC_TERMINAL

#include "cstools5.inc"
#include "telnet.inc"
#include "connect.inc"
#include "timer.inc"
#include "clipboard.inc"
#include "resource.inc"

#define WM_CLIENT_EVENT	0x8001

#define MB_OK                   0x00000000
#define MB_OKCANCEL             0x00000001
#define MB_ABORTRETRYIGNORE     0x00000002
#define MB_YESNOCANCEL          0x00000003
#define MB_YESNO                0x00000004
#define MB_RETRYCANCEL          0x00000005
#define MB_ICONHAND             0x00000010
#define MB_ICONQUESTION         0x00000020
#define MB_ICONEXCLAMATION      0x00000030
#define MB_ICONASTERISK         0x00000040
#define MB_ICONWARNING          MB_ICONEXCLAMATION
#define MB_ICONERROR            MB_ICONHAND
#define MB_ICONINFORMATION      MB_ICONASTERISK
#define MB_ICONSTOP             MB_ICONHAND
#define MB_APPLMODAL            0x00000000
#define MB_SYSTEMMODAL          0x00001000
#define MB_TASKMODAL            0x00002000

#define IDOK		1
#define IDCANCEL	2
#define IDABORT		3
#define IDRETRY		4
#define IDIGNORE	5
#define IDYES		6
#define IDNO		7
#define IDCLOSE		8
#define IDHELP		9

declare import,MessageBeep(int nType), int;
declare extern LoadString(unsigned int nStringId, opt unsigned int hModule = 0), heap;

class CMainWnd : CTerminal
{
	declare CMainWnd();
	declare _CMainWnd();

	// Message handlers
	declare OnCreate(), int;
	declare OnClose(), int;
	declare OnChar(unsigned int nChar, int nRepCnt), int;
	declare OnMappedKey(int nKeyIndex, int nShiftFlags, string strValue), int;
	declare OnMenuInit(unsigned int hMenu), int;
	declare OnMenuPick(int nID), int;
	declare OnMenuConnect(), int;
	declare OnMenuDisconnect(), int;
	declare OnMenuExit(), int;
	declare OnMenuMark(), int;
	declare OnMenuCopy(), int;
	declare OnMenuPaste(), int;
	declare OnMenuSelectAll(), int;
	declare OnMenuResize(), int;
	declare OnMenuAutoSize(), int;
	declare OnMenuSelectFont(), int;
	declare OnMenuForeColor(), int;
	declare OnMenuBackColor(), int;
	declare OnMenuOptions(), int;
	declare OnMenuColu(), int;
	
	ConnectInfo m_conInfo;
	CConnectTimer *m_pTimer;
	CClipboard m_clipboard;
	int m_bMarkingText;
}
#endif
