// SocketTools 5.0 Library Edition
// Copyright 2007 Catalyst Development Corporation
// All rights reserved
//
// This file is licensed to you pursuant to the terms of the
// product license agreement included with the original software,
// and is protected by copyright law and international treaties.
// Unauthorized reproduction or distribution may result in severe
// criminal penalties.
//
#ifndef _CTIMER_CLASS_INC
#define _CTIMER_CLASS_INC

class CTimer
{
	// Class constructor and destructor
	declare CTimer();
	declare _CTimer();

	// Class public methods
	declare GetElapsedTime(), unsigned int;
	declare ResetTimer();
	declare StartTimer(unsigned int nInterval, opt pointer lpParameter = null), int;
	declare StopTimer();

	// Class virtual methods
	declare virtual OnTimer(unsigned int nInterval, unsigned int nElapsed, pointer lpParameter);

	// Class member variables
	unsigned int m_nTimerId;
	unsigned int m_nInterval;
	unsigned int m_dwTimerStarted;
	unsigned int m_dwTimerStopped;
	pointer m_lpParameter;
}

class CConnectTimer:CTimer
{
	declare OnTimer(unsigned int nInterval, unsigned int nElapsed, pointer lpParameter);
}

#endif
